<template>
  <div class="item">
    <ul class="breadcrumbs">
      <li><router-link :to="{name: 'home'}" title="Автосервис в Красноярске">Главная</router-link></li>
      <li><router-link :to="{name: 'parts'}" title="Каталог автозапчастей в Красноярске">Каталог</router-link></li>
      <li>{{part.part_type_name}}</li>
    </ul>
    <div class="part">
      <div class="part__img" itemscope itemtype="http://schema.org/Product" @click="$refs.photo.open()">
        <div class="icon-search"></div>
        <img itemprop="image" title="title" :src="get_img_path(part)">
      </div>
      <div class="part__info" itemscope itemtype="http://schema.org/Product">
        <h1 itemprop="name" style="text-align: left; margin: 0 0 25px">{{part.part_type_name}}</h1>
        <table>
          <tbody>
          <tr><td>Автомобиль</td><td><strong itemprop="model">{{part.sma_name}} {{part.smo_name}}</strong></td></tr>
          <tr v-for="(value, key) in props_filter(part)">
            <td>{{map_description(key)}}</td>
            <td>{{value_format(value)}}</td>
          </tr>
          </tbody>
        </table>
      </div>
      <div class="part__buy" itemscope itemtype="http://schema.org/Offer">
        <p class="price" itemprop="price">{{part.price}}</p>
        <p class="instock"><span>{{part.part_status}}</span></p>
        <a v-if="in_cart(part)" class="item__button" @click="show_cart" rel="nofollow">Добавлено</a>
        <a v-else class="item__button" @click="add2cart(part)" rel="nofollow">В корзину</a>
      </div>
    </div><h1></h1>
    <sweet-modal ref="photo" width="800px">
      <img :src="get_img_path(part, '700x500')" />
    </sweet-modal>
  </div>
</template>

<script>
  import { SweetModal } from 'sweet-modal-vue'
  import { mapState, mapActions, mapGetters, mapMutations } from 'vuex';

  export default {
    name: 'part',
    data: () => {
      return {
        description: {
          // 'sma_name': 'Марка',
          // 'smo_name': 'Модель',
          // 'photos': 'Фото',
          // 'spt_name': 'Наименование запчасти',
          // 'part_status': 'Статус',
          // 'price': 'Цена',
          // 'sb_id': 'ID филиала',
          'sf_name': 'Кузов',
          'year_period_model': 'Период выпуска',
          'sma_name_ru': 'Марка по-русски',
          'sup_part_comment': 'Комментарий',
          'sup_discount': 'Процент скидки',
          'last_edit': 'Дата публикации',
          'smo_name_ru': 'Модель по-русски',
          'sup_invnn': 'Инвентарный номер',
          'id': 'ID товара',
          'se_name': 'Двигатель',
          'position': 'Расположение',
          'sup_device_code': 'Код производителя',
          'sup_oem_code': 'OEM код'
        }
      }
    },
    computed: {
      ...mapState('api', ['part']),
      ...mapGetters('cart', ['in_cart']),
    },
    methods: {
      ...mapActions('api', ['get_part']),
      ...mapMutations('cart', ['show_cart', 'add2cart']),
      get_img_path: function (part, size='370x265') {
        if (this.part.photos) {
          const path = this.part.photos.path;
          const item = this.part.photos.part[0];
          return `https://img.bibinet.ru${path}-${item}_c${size}.jpg`;
        } else {
          return '/img/big.jpg';
        }
      },
      props_filter: function(part) {
        const allowed = Object.keys(this.description);
        return Object.keys(this.part)
          .filter(key => allowed.includes(key))
          .reduce((obj, key) => {
            obj[key] = this.part[key];
            return obj;
          }, {});
      },
      map_description: function (field) {
        return this.description[field];
      },
      value_format(value) {
        if (value instanceof Array) {
          return value.join(', ');
        }
        return value;
      }
    },
    mounted() {
      const id = this.$route.params.id; //1197-385-7024570
      this.get_part(id);
    },
    components: {
      SweetModal
    }
  }
</script>
